include "Vram.inc"
include "VVram.inc"
include "Chars.inc"

ext XOffset_
ext VVram_

VramTop equ Vram+VramWidth*2


; void InitVram();
cseg
InitVram_: public InitVram_
    call ClearScreen_
    ; call ShowVram_
ret


; void ClearScreen();
ClearScreen_:
    public ClearScreen_
    push af | push hl | push bc
        ld hl,Vram
        ; ld (pCurrentVram_),hl
        ; ld a,h
        ; out (0FEH),a
        ld bc,VramWidth*VramHeight
        do
            ld (hl),Char_Space
            inc hl
            dec bc
            ld a,c
            or b
        while nz | wend
    pop bc | pop hl | pop af
ret


; ptr<byte> PrintC(ptr<byte> address, byte c);
cseg
CharTable:
    defb '-','0','1','2','3','4','5','6','7','8','9','A','B','C','E','F','G','H','I','M','N','O','P','R','S','T','U','V'
PrintC_: public PrintC_
    push af | push bc
        cp ' '
        if nz
            push hl
                ld bc,28*256+2
                ld hl,CharTable
                ld a,e
                do
                    cp (hl)
                    jr z,PrintC_break
                    inc hl
                    inc c
                dwnz
                PrintC_break:
                ld a,c
            pop hl
        else
            ld a,Char_Space
        endif
        ld (hl),a
        inc hl
    pop bc | pop af
ret


; void VVramToVram();
VVramToVram_: public VVramToVram_
    push af | push hl | push de | push bc
        ld hl,Vram+VramWidth*2-2
        ld a,(XOffset_)
        ld e,a
        ld d,0
        add hl,de
        ex de,hl
        ld hl,VVram_
        ld bc,VVramWidth*VVramHeight
        ldir
    pop bc | pop de | pop hl | pop af
ret
